#include "CEveOnlineAPI.hpp"
#include <string>
#include <windows.h>
#include <Wininet.h>
#include "API_URLs.hpp"


CEveOnlineAPI::CEveOnlineAPI(HINTERNET *pConnection, struct API_Type stAPIType )
{
	CEveOnlineAPI::mpConnectionHandle = *pConnection;
	CEveOnlineAPI::mwsAPIRequestURL += API_Server_Address;
	CEveOnlineAPI::mwsAPIRequestURL += stAPIType.API_URL;
	if (stAPIType.API_Number > 0){
		CEveOnlineAPI::mwsAPIRequestURL += L"?keyID=";
		CEveOnlineAPI::mwsAPIRequestURL += KeyID;
		CEveOnlineAPI::mwsAPIRequestURL += L"&vCode=";
		CEveOnlineAPI::mwsAPIRequestURL += VeriCode;
	};
};

CEveOnlineAPI::~CEveOnlineAPI()
{
};

int CEveOnlineAPI::GetXML()
{
	char Buffer[101];
	memset(Buffer, ' ', sizeof(Buffer));
	DWORD BytesRead = 0;
	HINTERNET GetAPIHandle = InternetOpenUrl(CEveOnlineAPI::mpConnectionHandle,
											 CEveOnlineAPI::mwsAPIRequestURL.c_str(),
											 NULL,
											 NULL,
											 NULL,
											 0
											 );
	if (GetAPIHandle == NULL){
		return 1;
	}
	else{
		do{
			InternetReadFile(GetAPIHandle,
							 Buffer,
							 100,
							 &BytesRead
							);
			Buffer[BytesRead] = '\0';
			CEveOnlineAPI::msXMLData.append(Buffer, Buffer + strlen(Buffer));
		} while (BytesRead != 0);
	};
	if (InternetCloseHandle(GetAPIHandle) != 1){
		return 2;
	}
	return 0;
}